let start;

// btnPressed
const btnPressed = (button) => {
  if (typeof button == "object") {
    return button.pressed;
  }
  return button == 1.0;
};


// padMonitor
const padMonitor = () => {

  const gamepads = navigator.getGamepads
    ? navigator.getGamepads()
    : navigator.webkitGetGamepads
    ? navigator.webkitGetGamepads
    : [];
  if (!gamepads) {
    return;
  }

  const gp = gamepads[0];

  // A
  if (btnPressed(gp.buttons[0])) {
    $('#gamepad .btn_a').show();
  } else {
    $('#gamepad .btn_a').hide();
  }
  // Y
  if (btnPressed(gp.buttons[3])) {
    $('#gamepad .btn_y').show();
  } else {
    $('#gamepad .btn_y').hide();
  }
  // B
  if (btnPressed(gp.buttons[1])) {
    $('#gamepad .btn_b').show();
  } else {
    $('#gamepad .btn_b').hide();
  }
  // X
  if (btnPressed(gp.buttons[2])) {
    $('#gamepad .btn_x').show();
  } else {
    $('#gamepad .btn_x').hide();
  }

  // LB
  if (btnPressed(gp.buttons[4])) {
    $('#gamepad .btn_lb').show();
  } else {
    $('#gamepad .btn_lb').hide();
  }
  // RB
  if (btnPressed(gp.buttons[5])) {
    $('#gamepad .btn_rb').show();
  } else {
    $('#gamepad .btn_rb').hide();
  }

  // LT
  if (btnPressed(gp.buttons[6])) {
    $('#gamepad .btn_lt').show();
  } else {
    $('#gamepad .btn_lt').hide();
  }
  // RT
  if (btnPressed(gp.buttons[7])) {
    $('#gamepad .btn_rt').show();
  } else {
    $('#gamepad .btn_rt').hide();
  }

  // メニュー
  if (btnPressed(gp.buttons[9])) {
    $('#gamepad .btn_mmenu').show();
  } else {
    $('#gamepad .btn_mmenu').hide();
  }

  // 左スティック左右：0
  var btn_ls_lr = gp.axes[0];
  var btn_ls_lr_show = false;
  if (btn_ls_lr > 0.1) {
    btn_ls_lr_show = true;
    $('#gamepad .btn_st').show();
    $('#gamepad .btn_st').addClass('right');
    $('#gamepad .btn_st').removeClass('left');
  } else if (btn_ls_lr < -0.1) {
    btn_ls_lr_show = true;
    $('#gamepad .btn_st').show();
    $('#gamepad .btn_st').addClass('left');
    $('#gamepad .btn_st').removeClass('right');
  } else {
    btn_ls_lr_show = false;
    $('#gamepad .btn_st').removeClass('left');
    $('#gamepad .btn_st').removeClass('right');
  }
  // 左スティック上下：1
  var btn_ls_ud = gp.axes[1];
  var btn_ls_ud_show = false;
  if (btn_ls_ud > 0.1) {
    btn_ls_ud_show = true;
    $('#gamepad .btn_st').show();
    $('#gamepad .btn_st').addClass('down');
    $('#gamepad .btn_st').removeClass('up');
  } else if (btn_ls_ud < -0.1) {
    btn_ls_ud_show = true;
    $('#gamepad .btn_st').show();
    $('#gamepad .btn_st').addClass('up');
    $('#gamepad .btn_st').removeClass('down');
  } else {
    btn_ls_ud_show = false;
    $('#gamepad .btn_st').removeClass('down');
    $('#gamepad .btn_st').removeClass('up');
  }

  // 非表示
  if(!btn_ls_lr_show && !btn_ls_ud_show){
    $('#gamepad .btn_st').hide();
  }

  // 十字キー（POV）でスティック反応させる
	// 上ボタン
  var cs_u = false;
  if (btnPressed(gp.buttons[12])) {
    cs_u = true;
  } else {
    cs_u = false;
  }
  // 下ボタン
  var cs_d = false;
  if (btnPressed(gp.buttons[13])) {
    cs_d = true;
  } else {
    cs_d = false;
  }
  // 左ボタン
  var cs_l = false;
  if (btnPressed(gp.buttons[14])) {
    cs_l = true;
  } else {
    cs_l = false;
  }
  // 右ボタン
  var cs_r = false;
  if (btnPressed(gp.buttons[15])) {
    cs_r = true;
  } else {
    cs_r = false;
  }
  if(cs_u) {
  	$('#gamepad .btn_st').show();
  	$('#gamepad .btn_st').addClass('up');
    if(cs_r){
    	$('#gamepad .btn_st').addClass('right');

    } else if(cs_l){
      $('#gamepad .btn_st').addClass('left');
    }
  }
  if(cs_r) {
  	$('#gamepad .btn_st').show();
  	$('#gamepad .btn_st').addClass('right');
    if(cs_d){
      $('#gamepad .btn_st').addClass('down');
    }
  }
  if(cs_d) {
  	$('#gamepad .btn_st').show();
  	$('#gamepad .btn_st').addClass('down');
    if(cs_l){
    	$('#gamepad .btn_st').addClass('left');
    }
  }
  if(cs_l) {
  	$('#gamepad .btn_st').show();
  	$('#gamepad .btn_st').addClass('left');
  }

  // stick_on
  if($('#gamepad .btn_st').is(':visible')) {
    $('#gamepad .stick_on').show();
  } else {
    $('#gamepad .stick_on').hide();
  }


  start = requestAnimationFrame(padMonitor);
};



window.addEventListener("gamepadconnected", (e) => {

  if($('#gamepad')[0]){
    $('#gamepad').removeClass('sleep');
  }
  if($('#gamepad .sleepin')[0]){
    $('#gamepad .sleepin').fadeOut(300);
  }

  padMonitor();


  console.log(
    "Gamepad connected at index %d: %s. %d buttons, %d axes.",
    e.gamepad.index,
    e.gamepad.id,
    e.gamepad.buttons.length,
    e.gamepad.axes.length
  );

  
});


